;******************************************************************************
;                     TFL-TDV Wired 96 SURPRISE CODING entry
;------------------------------------------------------------------------------
; Type One / TFL-TDV 
; Rodolphe
; Sam Le Pirate / TFL-TDV 
; Dr. Kami / MCD
;******************************************************************************

.MODEL TINY
.CODE
 org     100h
start:
.586

  int  16h        ; attend touche (ah = 0)
  cbw             ; extend to AX
  push ax         ; sauve clavier

  push 0A000h
  pop  es

  xor  cx,cx      

  mov  al,13h     ; boucle passe en 13h

encore:
  mov  di,319     ;  droite

  mov  dx,199
cassure:
  mov  bl,3       ; periode : 1,2,1,2,2 (8 pixels) 

next:             ; d'abord tracer droite de gauche a droite
  int  10h

modifmoi:
  inc  cx         ; 41 - code automodifiant : alterner inc et dec
                  ; avancer en X
  mov  ax,0C0Fh   ; plot en couleur 15  

  mov  si,cx      ; lignes horizontales
  mov  es:[si],al
  mov  es:[si+320*199],al

  test cl,111y    ; tester multiple de 8 
  jz   cassure    ; recommencer un pattern de 8 pixels

  dec  bx         ; pas monter en y pour le 3eme point
  jz   cassure

  stosb           ; tracer 2 verticales
  stosb
  add  di,320-2   ; descendre

  dec  dx         ; monter en Y
  jns  next 

  ; arrive en 320,-1

  xor  BYTE PTR [modifmoi], 8    ;49 -> mettre dec : tracer autre droite
  jnp  encore

; AL = fill color
; fill triangle 

  pop  bx         ; lire touche            

  mov  cx,198 

  test bl,1
  jz   no_shift
  shr  cl,1 
no_shift:

  shl  bl,1 
  mov  bp,WORD PTR table[bx-2-30h*2] ; index table+conversion   
  
; bp et cx determine ce qu'il faut : faut les calculer

grosfill:
  cld                           ; automodifier : cld/std
  mov  di,bp
fillscan:  
  stosb
  cmp  BYTE PTR es:[di],al      ; si collision avec ligne 
  jnz  fillscan  

  xor  BYTE PTR [grosfill],1    ; changer direction
  jnp  grosfill 
  add  bp,320 
  loop grosfill


  cbw             ; AH = 0 -> attend touche
  int  16h        ; attend touche

  mov  ax,3       ; mode texte
  int  10h

  ret             ; retour au DOS

table LABEL WORD
  DW 160,320,320*100+160,319

 END start


